/*=========================================================================
̃vÓAuvZXNvg Version 1.5v
i http://park1.wakwak.com/~y-nagano/Programs/koyomi/ j
C++ɈڐÂłB
=========================================================================*/

#ifndef _LUNISOLAR_BASE_H_
#define _LUNISOLAR_BASE_H_


// ǂ܂傤
#define LSCAL_TZ_OFFSET_JP (-9.0 / 24.0)


//---------------------------------------------------------------------------
/**
Zj\񋓌^B
*/
enum lscal_RokuyouIndex_t {
	lscal_6Y_Senshou    = 0,	// 揟
	lscal_6Y_Tomobiki   = 1,	// F
	lscal_6Y_Senpu      = 2,	// 敉
	lscal_6Y_Butsumetsu = 3,	// 
	lscal_6Y_Taian      = 4,	// 
	lscal_6Y_Shakkou    = 5 	// Ԍ
};

/**
\lߋC\񋓌^B
*/
enum lscal_SolarTerm_t {
	lscal_24S_Shunbun   =  0,	// t
	lscal_24S_Seimei    =  1,	// 
	lscal_24S_Kokuu     =  2,	// J
	lscal_24S_Rikka     =  3,	// 
	lscal_24S_Shouman   =  4,	// 
	lscal_24S_Boushu    =  5,	// 䊎
	lscal_24S_Geshi     =  6,	// Ď
	lscal_24S_Shousho   =  7,	// 
	lscal_24S_Taisho    =  8,	// 友
	lscal_24S_Risshuu   =  9,	// H
	lscal_24S_Shosho    = 10,	// 
	lscal_24S_Hakuro    = 11,	// I
	lscal_24S_Shuubun   = 12,	// H
	lscal_24S_Kanro     = 13,	// I
	lscal_24S_Soukou    = 14,	// ~
	lscal_24S_Rittou    = 15,	// ~
	lscal_24S_Shousetsu = 16,	// 
	lscal_24S_Taisetsu  = 17,	// 
	lscal_24S_Touji     = 18,	// ~
	lscal_24S_Shoukan   = 19,	// 
	lscal_24S_Taikan    = 20,	// 劦
	lscal_24S_Risshunn  = 21,	// t
	lscal_24S_Usui      = 22,	// J
	lscal_24S_Keichitsu = 23 	// [
};

/**
\iVj\񋓌^B
*/
enum lscal_HeavenlyStem_t {
	lscal_10K_Kinoe      =  0,	// b
	lscal_10K_Kinoto     =  1,	// 
	lscal_10K_Hinoe      =  2,	// 
	lscal_10K_Hinoto     =  3,	// 
	lscal_10K_Tsuchinoe  =  4,	// 
	lscal_10K_Tsuchinoto =  5,	// 
	lscal_10K_Kanoe      =  6,	// M
	lscal_10K_Kanoto     =  7,	// h
	lscal_10K_Mizunoe    =  8,	// p
	lscal_10K_Mizunoto   =  9 	// 
};

/**
\xinj\񋓌^B
*/
enum lscal_EarthlyBranch_t {
	lscal_12S_Ne      =  0,	// q
	lscal_12S_Ushi    =  1,	// N
	lscal_12S_Tora    =  2,	// 
	lscal_12S_U       =  3,	// K
	lscal_12S_Tatsu   =  4,	// C
	lscal_12S_Mi      =  5,	// 
	lscal_12S_Uma     =  6,	// 
	lscal_12S_Hitsuji =  7,	// 
	lscal_12S_Saru    =  8,	// \
	lscal_12S_Tori    =  9,	// 
	lscal_12S_Inu     = 10,	// 
	lscal_12S_I       = 11 	// 
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
/**
ti[邽߂̍\́B
*/
struct lscal_DateInfoBase {
	int year;	// N
	int month;	// 
	int date;	// 
	double jd;	// EXʓiJSTj
	double tzoffset;	// ^C][ItZbgiPʁF{Ȃ-0.375j
	bool leapMonth;	// [tOi[Ȃtruej
};

/**
tق낢ȏi[邽߂̍\́B
*/
struct lscal_DateInfo : public lscal_DateInfoBase {
	lscal_RokuyouIndex_t  rokuyou;	// Zj
	lscal_SolarTerm_t     solarTerm;	// \lߋC
	lscal_HeavenlyStem_t  heavenlyStemDay;	// ̏\
	lscal_EarthlyBranch_t earthlyBranchDay;	// ̏\x
	lscal_HeavenlyStem_t  heavenlyStemYear;	// N̏\
	lscal_EarthlyBranch_t earthlyBranchYear;	// N̏\x
	int moonPhase;	// 
	int lunation;	// ]
	double jdLunation;	// ]JD(UTC)
	double moonAge;	// 
	double moonAgeAtNoon;	// ߌ
	double illuminated;	// Pʔ
};

//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
/**
z̉o sun(t) vZB
@param t ͊wB
@return zoB
*/
double lscal_CalcLongitudeOfTheSun(double t);

/**
̉o moon(t) vZB
@param t ͊wB
@return oB
*/
double lscal_CalcLongitudeOfTheMoon(double t);

/**
O̓񕪓񎊂̉o sun0 ߂B

@param longitude ߂Ώہi90:񕪓,30:Cj
@param lambdaSun ݂̉o
@return O̓񕪓񎊂̉o sun0B
*/
double lscal_CalcLambdaSunZero(double longitude, double lambdaSun);

/**
w肵̑zo߂B

@param tm vZƂȂ鎞iJSTEXj
@param tzoffset ^C][ItZbgBUTC猩̂iPʁjB
@return zoԂB
*/
double lscal_CalcLambdaSun(double tm, double tzoffset);

/**
O̓񕪓񎊁^C̎߂B
͊wƃEXƂ̕␳0.0bƉ肷B
pƂāAoϐ LSCAL_RM_SUN0 ɁA̎̑zoZbgB

@param tm vZƂȂ鎞iJSTEXj
@param tzoffset ^C][ItZbgBUTC猩̂iPʁjB
@param lambdaSun0 O̓񕪓񎊂̉o sun0
@return ߂iJSTEXjԂB
*/
double lscal_CalcChuki(double tm,  double tzoffset, double lambdaSun0);

/**
O̍̎߂B
͊wƃEXƂ̕␳0.0bƉ肷B

@param tm vZ̎iJSTEXj
@param tzoffset ^C][ItZbgBUTC猩̂iPʁjB
@return ̎
*/
double lscal_CalcJDAtLastNewMoon(double tm, double tzoffset);

/**
vZB
@param tm JSTEXB
@param tzoffset ^C][ItZbgBUTC猩̂iPʁjB
@param result ʊi[p\̂ւ̎QƁBȂǂi[B
*/
void lscal_CalcLunisolarCalendar(double tm, double tzoffset, lscal_DateInfo & result);

/**
Ώۓ\lߋCɊY邩ǂ𒲂ׂB
Y΁AYԍԂB
@param jd JSTEXB
@param tzoffset ^C][ItZbgBUTC猩̂iPʁjB
@return \lߋC̔ԍ (0-23) -1Ȃ\lߋCO
*/
int lscal_CalcSolarTerm(double jd, double tzoffset);

/**
̏ZbgB
result.jdJSTEXAresult.tzoffsetɃ^C][ItZbg
ZbgԂŌĂяoƁB

@param saku1 ̎
@param saku2 ̎
@param result ʊi[p\̂ւ̎QƁB̏񂪊i[B
*/
void lscal_SetLCMoonInfo(double saku1, double saku2, lscal_DateInfo & result);

/**
ZjA\lߋCȂǂ̏ZbgB
result.jd, result.year, result.month, result.date, result.tzoffset
ZbgԂŌĂяoƁB

@param result ʊi[p\̂ւ̎QƁBZjA\lߋCȂǂ̏񂪒ǉi[B
*/
void lscal_SetLCTermInfo(lscal_DateInfo & result);


//---------------------------------------------------------------------------

#endif _LUNISOLAR_BASE_H_

