#ifndef _TVP_PLUGIN_MESSAGE_H_
#define _TVP_PLUGIN_MESSAGE_H_

#include "TJSEMessageStr.h"


#ifdef TVP_PLUGIN_NAME
# define TPM_MESSAGE_HEADER  (TJS_W("TVP Plugin(") TVP_PLUGIN_NAME ("): "))
#else
# define TPM_MESSAGE_HEADER  TJS_W("TVP Plugin: ")
#endif


#define TPM_E_JUST_A_BUG           TJS_W("oOłB\nP1=%1\nP2=%2")

// generic
#define TPM_E_OCTINDEX_OUT_OF_RANGE TJS_W("INebgɑ΂Ĕ͈͊Öʒuw肳܂B")
#define TPM_E_STRINDEX_OUT_OF_RANGE TJS_W("ɑ΂Ĕ͈͊Öʒuw肳܂B")

#define TPM_E_INVALID_DATE_TIME    TJS_W("sȓw肳܂B\n%1")
#define TPM_E_INVALID_TIMEZONE     TJS_W("sȃ^C][w肳܂B\n^C][='%1' Ď=%2")

#define TPM_E_NO_DATE_CMP_FIELD    TJS_W("LȔrtB[h܂B")
#define TPM_E_INVALID_DUMP_MODE    TJS_W("ȃINebgϊ[hw肳܂B")
#define TPM_E_NOT_IMPL_FUNC        TJS_W("̃IuWFNgɂ%1֐Ă܂B")
#define TPM_E_RIPEMD160_CTX_INIT_FAIL TJS_W("RIPEMD160ReLXg̏Ɏs܂B")
#define TPM_E_UNSUPPORTED_OS       TJS_W("OSi%1jł̓T|[gĂ܂B")

// system
#define TPM_E_PROCESS_INFO_FAIL    TJS_W("vZX擾ł܂łB\n%1")
#define TPM_E_PR_MODULE_INFO_FAIL  TJS_W("vZX̃W[擾ł܂łB\n%1")
#define TPM_E_PR_MEMORY_INFO_FAIL  TJS_W("vZX̃擾ł܂łB\n%1")
#define TPM_E_PR_TIME_INFO_FAIL    TJS_W("vZX̎ԏ擾ł܂łB\n%1")
#define TPM_E_PR_TOKEN_OPEN_FAIL   TJS_W("vZX̃ANZXg[NI[vł܂łB\n%1")
#define TPM_E_PR_TOKEN_INFO_FAIL   TJS_W("vZX̃ANZXg[N擾ł܂łB\n%1")
#define TPM_E_PR_ACCOUNT_USER_FAIL TJS_W("vZXs[ŨAJEg擾ł܂łB\n%1")
#define TPM_E_PR_IO_INFO_FAIL      TJS_W("vZXI/O擾ł܂łB\n%1")
#define TPM_E_PR_TIME_ZONE_FAIL    TJS_W("^C][擾ł܂łB\n%1")

#define TPM_E_MESSAGEBOX_FAIL      TJS_W("bZ[W{bNX̕\Ɏs܂B\n%1")
#define TPM_E_GET_PARENT_MENU_FAIL TJS_W("ej[̎擾Ɏs܂B\n%1")
#define TPM_E_GET_CHILD_MENU_FAIL  TJS_W("qj[̎擾Ɏs܂B\n%1")
#define TPM_E_POPUPMENU_FAIL       TJS_W("|bvAbvj[̕\Ɏs܂B\n%1")
#define TPM_E_CONVERT_COORD_FAIL   TJS_W("WϊɎs܂B\n%1")

#define TPM_E_COMPUTER_NAME_FAIL   TJS_W("Rs[^̎擾Ɏs܂B\n%1")
#define TPM_E_USER_NAME_FAIL       TJS_W("[U̎擾Ɏs܂B\n%1")
#define TPM_E_POWER_STATUS_FAIL    TJS_W("VXedԂ̎擾Ɏs܂B\n%1")

#define TPM_E_SHM_GET_FAIL         TJS_W("L̊mۂɎs܂B\n%1")
#define TPM_E_SHM_ATT_FAIL         TJS_W("L̕tɎs܂B\n%1")
#define TPM_E_SHM_DET_FAIL         TJS_W("L̕Ɏs܂B\n%1")
#define TPM_E_SHM_FREE_FAIL        TJS_W("L̉Ɏs܂B\n%1")
#define TPM_E_SHM_PEEK_FAIL        TJS_W("L̓ǂݍ݂Ɏs܂B\nZOgtĂȂAZOg̗̈OɃANZX悤Ƃ܂B")
#define TPM_E_SHM_POKE_FAIL        TJS_W("Lւ݂̏Ɏs܂B\nZOgtĂȂAZOg̗̈OɃANZX悤ƂA݌܂B")




// 摜n
#define TPM_E_UNSUPPORTED_FACE       TJS_W("ΉĂȂ`惂[hłB")
#define TPM_E_GRAD_ARRAY_TOO_SHORT   TJS_W("Fz̗vf܂iwF%1 KvF%2jB")
#define TPM_E_CALLBACK_NOT_SPECIFIED TJS_W("R[obN֐w肵ĂB")
#define TPM_E_INVALID_CURVE_TYPE     TJS_W("pgbNȐ̌^łB")
#define TPM_E_CTRL_POINTS_TOO_SHORT  TJS_W("_܂iwF%1 KvF%2jB")
#define TPM_E_CTRL_POINTS_TOO_MANY   TJS_W("_܂iwF%1 ő吔F%2jB")
#define TPM_E_INVALID_MORPH_RATIO    TJS_W("is͈͊OłB")
#define TPM_E_DIFFERENT_IMAGE_SIZE   TJS_W("C̃C[WTCY͑SēłȂ΂Ȃ܂B")
#define TPM_E_OUT_OF_RECT            TJS_W("`͂ݏo_܂܂Ă܂B")
#define TPM_E_SRC1_OUT_OF_RECT       TJS_W("ό`O̍WQɋ`͂ݏo_܂܂Ă܂B")
#define TPM_E_SRC2_OUT_OF_RECT       TJS_W("ό`̍WQɋ`͂ݏo_܂܂Ă܂B")
#define TPM_E_INVALID_PAINT_TYPE     TJS_W("hԂ̈̔@łB")
#define TPM_E_INVALID_LAYER_REF_TYPE TJS_W("C[W̔r@łB")

// SQLite3
#define TPM_E_SQ3_VERSATILE          TJS_W("%1 :\n%2")
#define TPM_E_SQ3_CLOSED_CONNECTION  TJS_W("DBɐڑĂ܂B")
#define TPM_E_SQ3_CLOSED_CURSOR      TJS_W("J[\łB")
#define TPM_E_SQ3_CLOSED_STATEMENT   TJS_W("Xe[ggłB")
#define TPM_E_SQ3_UNSUPPORTED_TYPE   TJS_W("T|[gĂȂf[^^łB")

#define TPM_I_SQLITE_ORIGINAL    TJS_W("\nResultCode: %1\nMessage: %2")
// TODO: 
#define TPM_E_SQLITE_OK          TJS_W("łB") TPM_I_SQLITE_ORIGINAL
#define TPM_E_SQLITE_ERROR       TJS_W("SQLG[łB") TPM_I_SQLITE_ORIGINAL
#define TPM_E_SQLITE_INTERNAL     2   /* NOT USED. Internal logic error in SQLite */
#define TPM_E_SQLITE_PERM         3   /* Access permission denied */
#define TPM_E_SQLITE_ABORT        4   /* Callback routine requested an abort */
#define TPM_E_SQLITE_BUSY         5   /* The database file is locked */
#define TPM_E_SQLITE_LOCKED       6   /* A table in the database is locked */
#define TPM_E_SQLITE_NOMEM        7   /* A malloc() failed */
#define TPM_E_SQLITE_READONLY     8   /* Attempt to write a readonly database */
#define TPM_E_SQLITE_INTERRUPT    9   /* Operation terminated by sqlite3_interrupt()*/
#define TPM_E_SQLITE_IOERR       10   /* Some kind of disk I/O error occurred */
#define TPM_E_SQLITE_CORRUPT     11   /* The database disk image is malformed */
#define TPM_E_SQLITE_NOTFOUND    12   /* NOT USED. Table or record not found */
#define TPM_E_SQLITE_FULL        13   /* Insertion failed because database is full */
#define TPM_E_SQLITE_CANTOPEN    14   /* Unable to open the database file */
#define TPM_E_SQLITE_PROTOCOL    15   /* Database lock protocol error */
#define TPM_E_SQLITE_EMPTY       16   /* Database is empty */
#define TPM_E_SQLITE_SCHEMA      17   /* The database schema changed */
#define TPM_E_SQLITE_TOOBIG      18   /* NOT USED. Too much data for one row */
#define TPM_E_SQLITE_CONSTRAINT  19   /* Abort due to contraint violation */
#define TPM_E_SQLITE_MISMATCH    20   /* Data type mismatch */
#define TPM_E_SQLITE_MISUSE      21   /* Library used incorrectly */
#define TPM_E_SQLITE_NOLFS       22   /* Uses OS features not supported on host */
#define TPM_E_SQLITE_AUTH        23   /* Authorization denied */
#define TPM_E_SQLITE_FORMAT      24   /* Auxiliary database format error */
#define TPM_E_SQLITE_RANGE       TJS_W("oChϐ̃CfbNXsłB") TPM_I_SQLITE_ORIGINAL
#define TPM_E_SQLITE_NOTADB      26   /* File opened that is not a database file */
#define TPM_E_SQLITE_ROW         100  /* sqlite3_step() has another row ready */
#define TPM_E_SQLITE_DONE        101  /* sqlite3_step() has finished executing */


// iconv
#define TPM_E_ICONV_OPEN_FAIL  TJS_W("%1%2ɂ͕ϊł܂B")
#define TPM_E_ICONV_INVALID_MB TJS_W("͂ɕsSȃ}`oCg񂪂܂B")
#define TPM_E_ICONV_UNKNOWN    TJS_W("s̃G[܂Bierrno=%1j")
#define TPM_E_ICONV_PUNY_FAIL  TJS_W("PunycodeϊɎs܂B")

// oCiXg[
#define TPM_E_BS_INVALID       TJS_W("ȃXg[łB")
#define TPM_E_BS_OPEN_FAIL     TJS_W("I[vł܂B\nt@CF%1")
#define TPM_E_BS_CLOSED        TJS_W("I[vĂ܂B")
#define TPM_E_BS_READ_FAIL     TJS_W("ǂݍ݂Ɏs܂B\nt@CF%1")
#define TPM_E_BS_WRITE_FAIL    TJS_W("݂Ɏs܂B\nt@CF%1")
#define TPM_E_BS_SEEK_FAIL     TJS_W("V[NɎs܂B\nt@CF%1")
#define TPM_E_BS_WRITE_ONLY    TJS_W("ǂݍ߂܂BݐpXg[łB\nt@CF%1")
#define TPM_E_BS_READ_ONLY     TJS_W("߂܂BǂݍݐpXg[łB\nt@CF%1")

// \Pbg
#define TPM_I_SOCKET_BASE  TJS_W("")
#define TPM_E_WSABASEERR             TJS_W("WSABASEERR : ")             TJS_W("G[͂܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEINTR               TJS_W("WSAEINTR : ")               TJS_W("VXeR[܂B\n֐Ăяof܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEBADF               TJS_W("WSAEBADF : ")               TJS_W("ȃt@CnhłB")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEACCES              TJS_W("WSAEACCES : ")              TJS_W("ANZXۂ܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEFAULT              TJS_W("WSAEFAULT : ")              TJS_W("obt@AhXłB")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEINVAL              TJS_W("WSAEINVAL : ")              TJS_W("Ȉn܂B\ngĂ͂ȂȂ\PbggƂ\܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEMFILE              TJS_W("WSAEMFILE : ")              TJS_W("gp̃\Pbg̐܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEWOULDBLOCK         TJS_W("WSAEWOULDBLOCK : ")         TJS_W("ubN܂B\nĂȂꍇ܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEINPROGRESS         TJS_W("WSAEINPROGRESS : ")         TJS_W("ubNꂽĂŒłB")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEALREADY            TJS_W("WSAEALREADY : ")            TJS_W("vꂽ͊ɎsA܂͎sς݂łB")  TPM_I_SOCKET_BASE
#define TPM_E_WSAENOTSOCK            TJS_W("WSAENOTSOCK : ")            TJS_W("w肳ꂽ\Pbgnh͖łB")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEDESTADDRREQ        TJS_W("WSAEDESTADDRREQ : ")        TJS_W("ɕKvȑM̃AhXw肳Ă܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEMSGSIZE            TJS_W("WSAEMSGSIZE : ")            TJS_W("f[^TCYvgŘEl𒴂Ă܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEPROTOTYPE          TJS_W("WSAEPROTOTYPE : ")          TJS_W("w肳ꂽ\PbǵAvꂽvgRɓKĂ܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAENOPROTOOPT         TJS_W("WSAENOPROTOOPT : ")         TJS_W("sȃvgRIvVw肳܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEPROTONOSUPPORT     TJS_W("WSAEPROTONOSUPPORT : ")     TJS_W("w肳ꂽvgR̓T|[gĂ܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAESOCKTNOSUPPORT     TJS_W("WSAESOCKTNOSUPPORT : ")     TJS_W("w肳ꂽ\Pbg^Cv̓T|[gĂ܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEOPNOTSUPP          TJS_W("WSAEOPNOTSUPP : ")          TJS_W("vꂽ̓T|[gĂ܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEPFNOSUPPORT        TJS_W("WSAEPFNOSUPPORT : ")        TJS_W("w肳ꂽvgRt@~̓T|[gĂ܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEAFNOSUPPORT        TJS_W("WSAEAFNOSUPPORT : ")        TJS_W("w肳ꂽAhXt@~̓T|[gĂ܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEADDRINUSE          TJS_W("WSAEADDRINUSE : ")          TJS_W("w肳ꂽAhX͊ɎgpłB")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEADDRNOTAVAIL       TJS_W("WSAEADDRNOTAVAIL : ")       TJS_W("w肳ꂽlbg[NAhX͖łB")  TPM_I_SOCKET_BASE
#define TPM_E_WSAENETDOWN            TJS_W("WSAENETDOWN : ")            TJS_W("sł܂B\nlbg[N_EĂ邩AguĂ܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAENETUNREACH         TJS_W("WSAENETUNREACH : ")         TJS_W("w肳ꂽzXgɓBł܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAENETRESET           TJS_W("WSAENETRESET : ")           TJS_W("lbg[Nڑj܂B\n炩̏Q̂߃^CAEgoAڑ܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAECONNABORTED        TJS_W("WSAECONNABORTED : ")        TJS_W("lbg[Nڑj܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAECONNRESET          TJS_W("WSAECONNRESET : ")          TJS_W("lbg[NڑɂĔj܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAENOBUFS             TJS_W("WSAENOBUFS : ")             TJS_W("obt@܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEISCONN             TJS_W("WSAEISCONN : ")             TJS_W("\Pbg͊ɐڑĂ܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAENOTCONN            TJS_W("WSAENOTCONN : ")            TJS_W("\Pbg͐ڑĂ܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAESHUTDOWN           TJS_W("WSAESHUTDOWN : ")           TJS_W("\Pbg͐ؒfłB")  TPM_I_SOCKET_BASE
#define TPM_E_WSAETOOMANYREFS        TJS_W("WSAETOOMANYREFS : ")        TJS_W("QƂĂ鐔܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAETIMEDOUT           TJS_W("WSAETIMEDOUT : ")           TJS_W("ڑv^CAEg܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAECONNREFUSED        TJS_W("WSAECONNREFUSED : ")        TJS_W("ڑۂ܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAELOOP               TJS_W("WSAELOOP : ")               TJS_W("[vĂ܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAENAMETOOLONG        TJS_W("WSAENAMETOOLONG : ")        TJS_W("w肳ꂽO͒܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEHOSTDOWN           TJS_W("WSAEHOSTDOWN : ")           TJS_W("ڑv^CAEg܂B\nzXg_EĂ܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEHOSTUNREACH        TJS_W("WSAEHOSTUNREACH : ")        TJS_W("zXgւ̌oH܂B\nlbg[N̍\zXgɓBłȂAAhXsłB")  TPM_I_SOCKET_BASE
#define TPM_E_WSAENOTEMPTY           TJS_W("WSAENOTEMPTY : ")           TJS_W("fBNgł͂܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEPROCLIM            TJS_W("WSAEPROCLIM : ")            TJS_W("vZX̐܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEUSERS              TJS_W("WSAEUSERS : ")              TJS_W("[U̐܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEDQUOT              TJS_W("WSAEDQUOT : ")              TJS_W("fBXN̊蓖Ă𒴉߂܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAESTALE              TJS_W("WSAESTALE : ")              TJS_W("s悤Ƃ͔p~Ă܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEREMOTE             TJS_W("WSAEREMOTE : ")             TJS_W("oH̃[gx܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSASYSNOTREADY         TJS_W("WSASYSNOTREADY : ")         TJS_W("lbg[NTuVXepł܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAVERNOTSUPPORTED     TJS_W("WSAVERNOTSUPPORTED : ")     TJS_W("WinSock DLL̃o[W͈͊OłB")  TPM_I_SOCKET_BASE
#define TPM_E_WSANOTINITIALISED      TJS_W("WSANOTINITIALISED : ")      TJS_W("WinSockVXeĂ܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEDISCON             TJS_W("WSAEDISCON : ")             TJS_W("ɂؒfłB")  TPM_I_SOCKET_BASE
#define TPM_E_WSAENOMORE             TJS_W("WSAENOMORE : ")             TJS_W("f[^͂ȏ㑶݂܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAECANCELLED          TJS_W("WSAECANCELLED : ")          TJS_W("͎܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEINVALIDPROCTABLE   TJS_W("WSAEINVALIDPROCTABLE : ")   TJS_W("T[rXvoC_̊֐e[ułB")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEINVALIDPROVIDER    TJS_W("WSAEINVALIDPROVIDER : ")    TJS_W("T[rXvoC_łB")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEPROVIDERFAILEDINIT TJS_W("WSAEPROVIDERFAILEDINIT : ") TJS_W("T[rXvoC_̏Ɏs܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSASYSCALLFAILURE      TJS_W("WSASYSCALLFAILURE : ")      TJS_W("VXeR[Ɏs܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSASERVICE_NOT_FOUND   TJS_W("WSASERVICE_NOT_FOUND : ")   TJS_W("w肳ꂽT[rX܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSATYPE_NOT_FOUND      TJS_W("WSATYPE_NOT_FOUND : ")      TJS_W("w肳ꂽ^Cv܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSA_E_CANCELLED        TJS_W("WSA_E_CANCELLED : ")        TJS_W("LZ܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAEREFUSED            TJS_W("WSAEREFUSED : ")            TJS_W("͋ۂꂽ܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSAHOST_NOT_FOUND      TJS_W("WSAHOST_NOT_FOUND : ")      TJS_W("w肳ꂽzXg܂B\nDNSȂǂ̖OT[rXł̓zXg܂łB")  TPM_I_SOCKET_BASE
#define TPM_E_WSATRY_AGAIN           TJS_W("WSATRY_AGAIN : ")           TJS_W("w肳ꂽzXgȂA܂̓T[rXُłB")  TPM_I_SOCKET_BASE
#define TPM_E_WSANO_RECOVERY         TJS_W("WSANO_RECOVERY : ")         TJS_W("񕜕s\ȃG[܂B\nf[^x[X̏ꍇ́AOT[rXgpłȂƂӖ܂B")  TPM_I_SOCKET_BASE
#define TPM_E_WSANO_DATA             TJS_W("WSANO_DATA : ")             TJS_W("vꂽ^Cṽf[^R[h܂B")  TPM_I_SOCKET_BASE






// gp
#define TPM_E_BS_READ_S_FALSE               TJS_W("ǂݍ݃G[łB")
#define TPM_E_BS_READ_E_PENDING             TJS_W("݂̃f[^͎gpł܂B")
#define TPM_E_BS_READ_STG_E_ACCESSDENIED    TJS_W("ǂݍ݋܂B")
#define TPM_E_BS_READ_STG_E_INVALIDPOINTER  TJS_W("|C^słBAoOłB")
#define TPM_E_BS_READ_STG_E_REVERTED        TJS_W("̃IuWFNg͖łigUNV̊߂߁jB")

#define TPM_E_BS_WRITE_E_PENDING            TJS_W("݂̃f[^͎gpł܂B")
#define TPM_E_BS_WRITE_STG_E_MEDIUMFULL     TJS_W("Xg[Wɋ󂫃Xy[X܂B")
#define TPM_E_BS_WRITE_STG_E_ACCESSDENIED   TJS_W("݋܂B")
#define TPM_E_BS_WRITE_STG_E_CANTSAVE       TJS_W("sȃANZXA󂫃Xy[XȂ߁A݂Ɏs܂B")
#define TPM_E_BS_WRITE_STG_E_INVALIDPOINTER TJS_W("|C^słBAoOłB")
#define TPM_E_BS_WRITE_STG_E_REVERTED       TJS_W("̃IuWFNg͖łigUNV̊߂߁jB")
#define TPM_E_BS_WRITE_STG_E_WRITEFAULT     TJS_W("fBXNG[łB")

#define TPM_E_BS_SEEK_STG_E_INVALIDPOINTER  TJS_W("|C^słBAoOłB")
#define TPM_E_BS_SEEK_STG_E_INVALIDFUNCTION TJS_W("sȈw肳܂B")
#define TPM_E_BS_SEEK_STG_E_REVERTED        TJS_W("̃IuWFNg͖łigUNV̊߂߁jB")


#endif
